<script lang="ts">
  import type { PVETask } from '@utils/SandboxApi';
  import type { Bundle, Environment, PveConfig } from '@models/Sandbox';
  import { EnvironmentState, environmentIsRunning } from '@models/Sandbox';
  import {
    createEnvironment,
    getEnvironmentExists,
    getEnvironmentTasks,
    startEnvironment,
    stopEnvironment,
    destroyEnvironmentById,
  } from '@utils/SandboxApi';
  import { pollUntil } from '@utils/async';
  import { Button } from '@sveltestrap/sveltestrap';
  import { onMount } from 'svelte';
  import { generateVmLink } from '@utils/SandboxUtils.js';
  import { keycloak } from '@stores';
  import { faSpinner } from '@fortawesome/free-solid-svg-icons';
  import Fa from 'svelte-fa';

  export let bundle: Bundle;
  export let environment: Environment | null | undefined;
  export let pveConfig: PveConfig;
  export let updateChallenges: () => Promise<void>;
  let stateChanging = false;

  onMount(async () => {
    // If the page is refreshed with pending tasks, then wait for them to complete before enabling buttons
    stateChanging = !!(environment && (await getEnvironmentTasks(environment!.id)).length > 0);
    if (stateChanging) {
      await waitForTasks();
      await updateChallenges();
      stateChanging = false;
    }
  });

  async function onCreateEnvironment() {
    if (!$keycloak.tokenParsed?.email) {
      throw new Error("failed to create environment: could not get user's email");
    }
    if (!bundle?.id) {
      throw new Error('failed to create environment: could not get bundle ID');
    }
    stateChanging = true;
    try {
      environment = await createEnvironment({
        owner: $keycloak.tokenParsed.email,
        bundle: bundle.id,
      });
      // environment = await pollUntil(
      //   () => getEnvironmentById(environment!.id), // ! because env is set after createEnvironment
      //   (env: Environment) => env.state !== EnvironmentState.creating,
      // );
      // old API returns new status immediately, so we poll the task list instead
      await waitForTasks();
      await updateChallenges();
    } finally {
      stateChanging = false;
    }
  }

  async function onStartEnvironment() {
    if (!environment?.id) throw new Error('can not start non-existent environment');
    stateChanging = true;
    try {
      environment = await startEnvironment(environment.id);
      environment.state = EnvironmentState.starting; // mimic status
      // poll env until it's done starting, then get updated status
      // environment = await pollUntil<Environment>(
      //   () => getEnvironmentById(environment!.id),
      //   (env: Environment) => env.state === EnvironmentState.running,
      // );
      // old API returns new status immediately, so we poll the task list instead
      await waitForTasks();
      // reload challenges from API
      await updateChallenges();
    } finally {
      stateChanging = false;
    }
  }

  async function onStopEnvironment() {
    if (!environment?.id) throw new Error('can not start non-existent environment');
    stateChanging = true;
    try {
      environment = await stopEnvironment(environment.id);
      environment.state = EnvironmentState.stopping; // mimic status
      // poll env until it's done stopping, then get updated status
      // environment = await pollUntil<Environment>(
      //   () => getEnvironmentById(environment!.id),
      //   (env: Environment) => env.state === EnvironmentState.stopped,
      // );
      // old API returns new status immediately, so we poll the task list instead
      await waitForTasks();
      // reload challenges from API
      await updateChallenges();
    } finally {
      stateChanging = false;
    }
  }

  async function onDestroyEnvironment() {
    if (!environment?.id) throw new Error('can not start non-existent environment');
    const environmentId = environment.id;
    stateChanging = true;
    try {
      // start env and get updated status
      environment = await destroyEnvironmentById(environmentId);
      // poll env until it no longer exists
      await pollUntil(
        () => getEnvironmentExists(environmentId),
        (exists: boolean) => !exists,
      );
      // environment = null;
      // reload challenges from API
      await updateChallenges();
    } finally {
      stateChanging = false;
    }
  }

  async function onLaunchEnvironment() {
    // todo
    // todo generate PVE links
  }

  async function waitForTasks() {
    // poll task list until no more active tasks exist
    await pollUntil(
      () => getEnvironmentTasks(environment!.id),
      (tasks: PVETask[]) => tasks.length === 0,
    );
  }

  function getVmLink(): string {
    if (!environment?.vmids?.length > 0) return pveConfig.url; // no link to provide
    // todo verify the user actually has permission for the VM we're launching them into
    return generateVmLink(pveConfig, Math.min(...environment.vmids), 'qemu');
  }
</script>

<div class="justify-content-end d-flex">
  {#if !environment}
    <Button disabled={stateChanging} class="clickable mb-2 ms-2" color="success" on:click={onCreateEnvironment}>
      {#if stateChanging}
        <!-- If state is changing _and_ environment doesn't exist, we're _probably_ deploying -->
        <!-- This isn't perfect logic -->
        <Fa icon={faSpinner} pulse />
        Deploying...
      {:else}
        Deploy Challenge
      {/if}
    </Button>
  {:else}
    <!-- ENVIRONMENT EXISTS -->
    {#key environment.state}
      <Button class="clickable mb-2 ms-2" color="danger" on:click={onDestroyEnvironment} disabled={stateChanging}>
        {#if environment.state === EnvironmentState.deleting}
          <Fa icon={faSpinner} pulse />
          Destroying...
        {:else}
          Destroy Environment
        {/if}
      </Button>
      {#if environmentIsRunning(environment)}
        <Button class="clickable mb-2 ms-2" color="secondary" on:click={onStopEnvironment} disabled={stateChanging}>
          {#if environment.state === EnvironmentState.stopping}
            <Fa icon={faSpinner} pulse />
            Shutting Down...
          {:else}
            Shutdown Environment
          {/if}
        </Button>
        <Button class="clickable mb-2 ms-2" color="primary" disabled={stateChanging} href={getVmLink()} target="_blank">
          Launch Environment
        </Button>
      {:else}
        <Button
          class="clickable mb-2 ms-2"
          color="success"
          on:click={onStartEnvironment}
          outline
          disabled={stateChanging}
        >
          {#if environment.state === EnvironmentState.starting}
            <Fa icon={faSpinner} pulse />
            Starting...
          {:else}
            Start Environment
          {/if}
        </Button>
      {/if}
    {/key}
  {/if}
</div>
